unit Unit3;

interface

uses forms, Classes;

type TFormProxy = class
  private
      InstanceClass : TComponentClass;
      Reference : TForm;
      Parent : TComponent;
  protected
  public
    constructor Create(ParentComponent : TComponent; TOrigForm: TComponentClass);
    Procedure Show;
  published
  end;

implementation

constructor TFormProxy.Create(ParentComponent : TComponent; TOrigForm: TComponentClass);
begin
     Parent:=ParentComponent;
     InstanceClass:=TOrigForm;
     Reference:=nil;
end;


procedure TFormProxy.Show;
var Instance: TComponent;
begin
     if Reference=nil
     then
     begin
          Instance := TComponent(InstanceClass.NewInstance);
          TComponent(Reference) := Instance;
          try
             Instance.Create(Parent);
          except
             TComponent(Reference) := nil;
             raise;
          end;
     end;
     Reference.Show;
end;


end.
